Index: tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/SVGSWTChartsComponentsProvider.java
===================================================================
--- tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/SVGSWTChartsComponentsProvider.java	(revision 536)
+++ tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/SVGSWTChartsComponentsProvider.java	(revision 537)
@@ -22,6 +22,7 @@
 import org.txm.chartsengine.rcp.editors.ChartEditorInput;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
 import org.txm.chartsengine.rcp.swt.ChartComposite;
+import org.txm.chartsengine.svgbatik.rcp.swing.SVGPanel;
 import org.txm.chartsengine.svgbatik.rcp.swt.SVGComposite;
 import org.w3c.dom.Element;
 
@@ -50,21 +51,16 @@
 	@Override
 	public boolean createChartContainer(ChartsEngine chartsEngine, ChartEditorInput chartEditorInput)	{
 
-		Object chart = chartEditorInput.getChart();
+		if (!chartEditorInput.getResult().isChartDirty()) {
 		
-		//if(chart != null)	{
-			chartEditorInput.setChartContainer(chart);
+			chartEditorInput.setChartContainer(new SVGPanel());
 			
 			// sets and updates the local preferences node qualifier from the result data
 			chartEditorInput.syncLocalPreferencesNode();
-
-
 			
 			return true;
-		//}
-		
-		
-		//return false;
+		}
+		return false;
 	}
 
 
Index: tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swing/SVGPanel.java
===================================================================
--- tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swing/SVGPanel.java	(revision 536)
+++ tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swing/SVGPanel.java	(revision 537)
@@ -29,7 +29,6 @@
 
 
 import java.awt.BorderLayout;
-import java.awt.Frame;
 import java.awt.event.InputEvent;
 import java.awt.event.MouseEvent;
 import java.awt.event.MouseWheelEvent;
@@ -49,7 +48,6 @@
 import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
 import org.txm.chartsengine.rcp.events.ChartKeyListener;
-import org.txm.utils.logger.Log;
 import org.w3c.dom.svg.SVGDocument;
 
 /**
@@ -91,7 +89,7 @@
 	 *
 	 * @param frame the frame
 	 */
-	public SVGPanel(ChartEditorPart editor, Frame frame)	{
+	public SVGPanel()	{
 		super(new BorderLayout());
 
 		this.svgCanvas = new JSVGCanvas(null, true, false);
@@ -209,7 +207,7 @@
 		// add default chart key listener
 		this.addKeyListener(new ChartKeyListener(SWTChartsComponentsProvider.getCurrent(), this, 10.5));
 		
-		this.setChartEditor(editor);
+		//this.setChartEditor(editor);
 		
 
 	}
Index: tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java	(revision 536)
+++ tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java	(revision 537)
@@ -927,11 +927,11 @@
 	 */
 	public static File export(Object chart, File file, String outputFormat, int imageWidth, int imageHeight, int drawingAreaX, int drawingAreaY, int drawingAreaWidth, int drawingAreaHeight)	{
 		// SVG
-		if(outputFormat == OUTPUT_FORMAT_SVG)	{
+		if(outputFormat.equals(OUTPUT_FORMAT_SVG))	{
 			return JFCChartsEngine.exportSVG((JFreeChart) chart, file, imageWidth, imageHeight, drawingAreaX, drawingAreaY, drawingAreaWidth, drawingAreaHeight);
 		}
 		// PDF
-		else if(outputFormat == OUTPUT_FORMAT_PDF)	{
+		else if(outputFormat.equals(OUTPUT_FORMAT_PDF))	{
 			return JFCChartsEngine.exportPDF((JFreeChart) chart, file, imageWidth, imageHeight, drawingAreaX, drawingAreaY, drawingAreaWidth, drawingAreaHeight);
 		}
 		// Raster
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 536)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 537)
@@ -3,10 +3,42 @@
  */
 package org.txm.progression.rcp.editors;
 
+import java.util.ArrayList;
+import java.util.List;
+import java.util.regex.Pattern;
+import java.util.regex.PatternSyntaxException;
+
 import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.ScrolledComposite;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.layout.FormAttachment;
+import org.eclipse.swt.layout.FormData;
+import org.eclipse.swt.layout.FormLayout;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Combo;
 import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.Group;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Listener;
+import org.eclipse.swt.widgets.Text;
+import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
-import org.txm.progression.rcp.forms.ProgressionParametersComposite;
+import org.txm.core.messages.TXMCoreMessages;
+import org.txm.progression.core.functions.Progression;
+import org.txm.progression.core.preferences.ProgressionPreferences;
+import org.txm.progression.rcp.dialogs.ProgressionDialog;
+import org.txm.rcp.RCPMessages;
+import org.txm.rcp.StatusLine;
+import org.txm.rcp.swt.widget.AssistedQueryWidget;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.utils.logger.Log;
 
 /**
  * Progression command chart editor.
@@ -14,15 +46,97 @@
  *
  */
 public class ProgressionEditor extends ChartEditorPart {
+
 	
+	/** The query widgets. */
+	protected List<AssistedQueryWidget> queryWidgets = new ArrayList<AssistedQueryWidget>();
+	
+	/** The queries. */
+	List<Query> queries;
+	
+	/** The corpus. */
+	private Corpus corpus;
+	
+	/** The selected structural unit. */
+	private StructuralUnit selectedStructuralUnit;
+	
+	/** The selected structural unit property. */
+	private StructuralUnitProperty selectedStructuralUnitProperty;
+	
+	/** The regexproperty value. */
+	private String regexpropertyValue;
+	
+	/** The graphtype. */
+	private boolean cumulative = true;
+	
+	private boolean blackAndWhite = true;
+	
+	/** The monostyle. */
+	private boolean monostyle = true;
+	
+	/** The repeatvalues. */
+	private boolean repeatvalues = false;
+	
+	/** The linewidth. */
+	private int linewidth = 2;
+	
+	/** The bandemultiplier. */
+	private float bandemultiplier = 2;
+
+	
+	/** The structural units combo. */
+	Combo structuralUnitsCombo;
+	
+	/** The structural units. */
+	List<StructuralUnit> structuralUnits;
+	
+	/** The structural units properties. */
+	List<StructuralUnitProperty> structuralUnitsProperties;
+	
+	/** The property combo. */
+	private Combo propertyCombo;
+	
+	/** The regex value. */
+	private Text regexValue;
+
+	/** The focus composite. */
+	Composite queriesFocusComposite;
+	
+	/** The main panel. */
+	Composite mainPanel;
+	
+	/** The bande field. */
+	Text bandeField;
+	
+	/** The cumu button. */
+	Button cumuButton;
+	
+	/** The repeat button. */
+	Button repeatButton;
+	
+	/** The style button. */
+	Button styleButton;
+	
+	/** The colors. */
+	String[] colors = DefaultTheme.colors;
+	
+	/** The self. */
+	ProgressionDialog self;
+	
+	/** The parent. */
+	private Composite parent;
+
+	private ScrolledComposite sc1;
+
+	
 	@Override
 	public void createPartControl(Composite parent) {
 		super.createPartControl(parent);
 		
 		
 		// FIXME: tests parameters composite extension
-		new ProgressionParametersComposite(this.getCommandParametersGroup(), SWT.NONE);
-		this.getCommandParametersGroup().pack();
+//		new ProgressionParametersComposite(this.getCommandParametersGroup(), SWT.NONE);
+//		this.getCommandParametersGroup().pack();
 
 		// FIXME: tests to use Fields editor and ScopedPreferenceStore for command parameters
 //		BooleanFieldEditor field = new BooleanFieldEditor(ChartsEnginePreferences.SHOW_TITLE, "test2 show title store", editor.getParametersComposite());
@@ -60,7 +174,361 @@
 //	    sendToCoorccurrence.setImage(IImageKeys.getImage(IImageKeys.ACTION_COOCCURRENCE));
 //	    sendToCoorccurrence.addSelectionListener(new ProgressionSelectionListener(editor, BaseSelectionListener.SEND_TO_COOCCURRENCE));
 //	    //*****************************************************
+	
 		
+		try {
+
+			monostyle = this.getBooleanParameterValue(ProgressionPreferences.CHART_MONO_STYLE);
+			cumulative = this.getBooleanParameterValue(ProgressionPreferences.CHART_CUMULATIVE);
+			repeatvalues = this.getBooleanParameterValue(ProgressionPreferences.CHART_REPEAT_VALUES);
+			bandemultiplier = this.getFloatParameterValue(ProgressionPreferences.CHART_BANDE_MULTIPLIER);
+
+			// System.out.println(parent.getLayout());
+			FormLayout mainlayout = new FormLayout();
+			Composite mainPanel = this.getCommandParametersGroup();
+			mainPanel.setLayout(mainlayout);
+			GridData gridData = new GridData(GridData.FILL, GridData.FILL, true, true);
+			mainPanel.setLayoutData(gridData);
+
+			Composite paramPanel = new Composite(mainPanel, SWT.NONE);
+
+			FormData paramPanelData = new FormData();
+			paramPanelData.top = new FormAttachment(0);
+			paramPanelData.left = new FormAttachment(0);
+			paramPanelData.right = new FormAttachment(100);
+			paramPanel.setLayoutData(paramPanelData);
+
+
+			paramPanel.setLayout(new GridLayout(3, true));
+			
+			// controls
+			// graph param
+			Label typeLabel = new Label(paramPanel, SWT.NONE);
+			typeLabel.setText(RCPMessages.ProgressionDialog_1);
+			typeLabel.setAlignment(SWT.CENTER);
+
+			cumuButton = new Button(paramPanel, SWT.RADIO);
+			cumuButton.setText(RCPMessages.ProgressionDialog_2);
+			cumuButton.setSelection(cumulative);
+
+			Button densityButton = new Button(paramPanel, SWT.RADIO);
+			densityButton.setText(RCPMessages.ProgressionDialog_3);
+			densityButton.setSelection(!cumulative);
+
+			//Bande size
+			typeLabel = new Label(paramPanel, SWT.NONE);
+			typeLabel.setText(RCPMessages.ProgressionDialog_11);
+			typeLabel.setAlignment(SWT.CENTER);
+
+			bandeField = new Text(paramPanel, SWT.BORDER);
+			bandeField.setText("" + bandemultiplier); //$NON-NLS-1$
+			bandeField.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true, 2, 1));
+			
+			// Structural units
+//			Group displayParam = new Group(paramPanel, SWT.BORDER);
+//			displayParam.setText(RCPMessages.ProgressionDialog_13);
+//			displayParam.setLayout(new GridLayout(3, true));
+//			displayParam.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true, 3, 1));
+
+			Label structLabel = new Label(paramPanel, SWT.NONE);
+			structLabel.setText(RCPMessages.ProgressionDialog_4);
+			structLabel.setAlignment(SWT.CENTER);
+
+			structuralUnitsCombo = new Combo(paramPanel, SWT.READ_ONLY);
+			structuralUnitsCombo.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true, 2, 1));
+
+			structuralUnitsCombo.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) {
+				}
+
+				@Override
+				public void widgetSelected(SelectionEvent event) {
+					getSite().getShell().getDisplay().syncExec(new Runnable() {
+						@Override
+						public void run() {
+							reloadSUProperties();
+							getResultData().setStructuralUnit(structuralUnits.get(structuralUnitsCombo.getSelectionIndex() - 1));
+							getResultData().setDirty();
+							computeChart(true);
+						}
+					});
+				}
+			});
+
+			
+			int selectedSUIndex = 0;
+			// get
+			try {
+				structuralUnitsCombo.add("    "); //$NON-NLS-1$
+				structuralUnits = this.getResultData().getCorpus().getOrderedStructuralUnits();
+				for(int i = 0; i < structuralUnits.size(); i++) {
+					structuralUnitsCombo.add(structuralUnits.get(i).getName());
+					if(getResultData().getStructure() == structuralUnits.get(i))	{
+						selectedSUIndex = (i + 1);
+					}
+				}
+			} catch (Exception e) {
+				Log.severe(RCPMessages.ObjectExplorer_9 + Log.toString(e));
+				e.printStackTrace();
+			}
+			structuralUnitsCombo.select(selectedSUIndex);
+			
+			// Structural unit properties
+			Label propLabel = new Label(paramPanel, SWT.NONE);
+			propLabel.setText(TXMCoreMessages.PROPERTY_1);
+			propLabel.setAlignment(SWT.CENTER);
+
+			propertyCombo = new Combo(paramPanel, SWT.READ_ONLY);
+			propertyCombo.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true, 2, 1));
+			reloadSUProperties();
+			
+			propertyCombo.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) {
+				}
+
+				@Override
+				public void widgetSelected(SelectionEvent event) {
+					getSite().getShell().getDisplay().syncExec(new Runnable() {
+						@Override
+						public void run() {
+							getResultData().setStructuralUnitProperty(structuralUnitsProperties.get(propertyCombo.getSelectionIndex() - 1));
+							getResultData().setDirty();
+							computeChart(true);
+						}
+					});
+				}
+			});
+			
+			
+			
+			// property value field
+			Label regexLabel = new Label(paramPanel, SWT.NONE);
+			regexLabel.setText(RCPMessages.ProgressionDialog_7);
+			regexLabel.setAlignment(SWT.CENTER);
+
+			regexValue = new Text(paramPanel, SWT.SINGLE | SWT.BORDER);
+			regexValue.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true, 2, 1));
+			if(this.getResultData().getPropertyRegex() != null)	{
+				regexValue.setText(getResultData().getPropertyRegex());
+			}
+			
+			//spacer
+			styleButton = new Button(paramPanel, SWT.CHECK);
+			styleButton.setText(RCPMessages.ProgressionDialog_14);
+			styleButton.setSelection(monostyle);
+
+			//Repeat options
+			repeatButton = new Button(paramPanel, SWT.CHECK);
+			repeatButton.setText(RCPMessages.ProgressionDialog_15);
+			repeatButton.setSelection(repeatvalues);
+
+			
+			
+			// Queries
+			sc1 = new ScrolledComposite(mainPanel, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
+			sc1.setLayout(new GridLayout(1, true));
+			sc1.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
+			sc1.setExpandHorizontal(true);
+			sc1.setExpandVertical(true);
+			sc1.setMinSize(0, 120);
+			
+			FormData queriesPanelData = new FormData();
+			queriesPanelData.top = new FormAttachment(paramPanel);
+			queriesPanelData.left = new FormAttachment(0);
+			queriesPanelData.right = new FormAttachment(100);
+			queriesPanelData.bottom = new FormAttachment(100);
+			sc1.setLayoutData(queriesPanelData);
+
+			queriesFocusComposite = new Composite(sc1, SWT.NONE);
+			queriesFocusComposite.setLayout(new GridLayout(1, true));
+			sc1.setContent(queriesFocusComposite);
+			
+			// queries parameters
+			Label focusLabel = new Label(queriesFocusComposite, SWT.NONE);
+			focusLabel.setText(RCPMessages.ProgressionDialog_8);
+			focusLabel.setAlignment(SWT.CENTER);
+
+			// add query button
+			Button plusButton = new Button(queriesFocusComposite, SWT.NONE);
+			plusButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
+					true, true));
+			plusButton.setText(RCPMessages.ProgressionDialog_9);
+			
+			plusButton.addListener(SWT.Selection, new Listener() {
+				@Override
+				public void handleEvent(Event event) {
+					if (colors.length > queryWidgets.size()) {
+						Log.info("add query field");
+						addFocusQueryField();
+						sc1.layout(true);
+						queriesFocusComposite.layout(true);
+						sc1.setMinSize(queriesFocusComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+					}
+				}
+			});
+
+			// delete query button
+			Button minusButton = new Button(queriesFocusComposite, SWT.NONE);
+			minusButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
+			minusButton.setText(RCPMessages.ProgressionDialog_5);
+			minusButton.addListener(SWT.Selection, new Listener() {
+				@Override
+				public void handleEvent(Event event) {
+					if (queryWidgets.size() > 0) {
+						// System.out.println("remove field");
+						AssistedQueryWidget lastwidget = queryWidgets.get(queryWidgets.size() - 1);
+						lastwidget.setSize(200, 30);
+						queryWidgets.remove(queryWidgets.size() - 1);
+						lastwidget.dispose();
+						sc1.layout(true);
+						queriesFocusComposite.layout(true);
+						sc1.setMinSize(queriesFocusComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+					}
+				}
+			});
+
+			// fill fields from result data
+			queries = this.getResultData().getQueries();
+			if (queries == null) {
+				addFocusQueryField();
+			}
+			else {
+				for (Query q : queries) {
+					addFocusQueryField().setText(q.getQueryString());
+				}
+			}
+			
+			
+			// Compute button
+			Button computeButton = new Button(paramPanel, SWT.NONE);
+			computeButton.setText("Compute");
+			computeButton.addSelectionListener(new SelectionListener() {
+				
+				@Override
+				public void widgetSelected(SelectionEvent evt) {
+					// TODO Auto-generated method stub
+					queries = new ArrayList<Query>();
+					for (AssistedQueryWidget wid : queryWidgets) {
+						if (!wid.getQueryString().equals("\"\"")) { //$NON-NLS-1$
+							queries.add(new Query(wid.getQueryString()));
+							wid.memorize();
+						}
+					}
+
+					if (propertyCombo.getSelectionIndex() > 0) {
+						selectedStructuralUnitProperty = structuralUnitsProperties.get(propertyCombo.getSelectionIndex() - 1);
+					}
+					else {
+						selectedStructuralUnitProperty = null;
+					}
+					if (structuralUnitsCombo.getSelectionIndex() > 0) {
+						selectedStructuralUnit = structuralUnits.get(structuralUnitsCombo.getSelectionIndex() - 1);
+					}
+					else {
+						selectedStructuralUnit = null;
+						selectedStructuralUnitProperty = null;// need a structuralunit
+					}
+
+					try {
+						Pattern.compile(regexValue.getText());
+						regexpropertyValue = regexValue.getText();
+
+						if (regexpropertyValue.length() == 0) {
+							regexpropertyValue = null;
+						}
+					} catch (PatternSyntaxException e) {
+						System.out.println(RCPMessages.ProgressionDialog_10 + e);
+					}
+
+					cumulative = cumuButton.getSelection();
+					monostyle = styleButton.getSelection();
+					repeatvalues = repeatButton.getSelection();
+					String smultibande = bandeField.getText();
+					if (smultibande != null && smultibande.length() > 0) {
+						try {
+							bandemultiplier = Float.parseFloat(smultibande);
+						} catch(Exception e) {
+							bandemultiplier = 1.0f;
+							System.out.println(RCPMessages.ProgressionDialog_17+e);
+							StatusLine.error(RCPMessages.ProgressionDialog_17+e);
+						}
+					}
+					else	{
+						bandemultiplier = 1.0f;
+					}
+
+					((Progression)getResultData()).setParameters(queries, selectedStructuralUnit, selectedStructuralUnitProperty, regexpropertyValue, cumulative, linewidth, repeatvalues, bandemultiplier);
+					computeChart(false);
+					
+				}
+				
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) {
+					// TODO Auto-generated method stub
+					
+				}
+			});
+			
+		} catch (Exception e) {
+			Log.printStackTrace(e);
+		}
+		
+		
 	}
 	
+	/**
+	 * Reloads the properties of the current selected structural unit.
+	 */
+	private void reloadSUProperties() {
+		
+		propertyCombo.removeAll();
+		propertyCombo.add("    "); //$NON-NLS-1$
+
+		int selectedSUPIndex = 0;
+		
+		if (structuralUnitsCombo.getSelectionIndex() > 0) {
+			selectedStructuralUnit = structuralUnits.get(structuralUnitsCombo.getSelectionIndex() - 1);
+			structuralUnitsProperties = selectedStructuralUnit.getOrderedProperties();
+			
+			for(int i = 0; i < structuralUnitsProperties.size(); i++) {
+				propertyCombo.add(structuralUnitsProperties.get(i).getName());
+				if(getResultData().getProperty() == structuralUnitsProperties.get(i))	{
+					selectedSUPIndex = (i + 1);
+				}
+			}
+		}
+		if (propertyCombo.getItemCount() > 0) {
+			propertyCombo.select(selectedSUPIndex);
+		}
+	}
+	
+	/**
+	 * Adds a query field.
+	 *
+	 * @return the assisted query widget
+	 */
+	private AssistedQueryWidget addFocusQueryField(String text) {
+		AssistedQueryWidget focusTextBox = new AssistedQueryWidget(queriesFocusComposite, SWT.BORDER, this.getResultData().getCorpus());
+		GridData gridData = new GridData(GridData.FILL, GridData.FILL, true, false);
+		focusTextBox.setLayoutData(gridData);
+		focusTextBox.setFocus();
+		queryWidgets.add(focusTextBox);
+		return focusTextBox;
+	}
+
+	/**
+	 * Adds an empty query field.
+	 * @return
+	 */
+	private AssistedQueryWidget addFocusQueryField() {
+		return this.addFocusQueryField("");
+	}
+
+	
+	@Override
+	public Progression getResultData() {
+		return (Progression) super.getResultData();
+	}
 }
